# Class DefaultParametricCRS

Object
FormattableObject
AbstractIdentifiedObject
AbstractReferenceSystem
AbstractCRS
DefaultParametricCRS

All Implemented Interfaces:
  `Serializable`, `Formattable`, `Deprecable`, `LenientComparable`, `Printable`, `CoordinateReferenceSystem`, `SingleCRS`, `IdentifiedObject`, `ReferenceSystem`

public class DefaultParametricCRS extends AbstractCRS
A 1-dimensional coordinate reference system which uses parameter values or functions. Parametric CRS can be used for physical properties or functions that vary monotonically with height. A typical example is the pressure in meteorological applications.

Used with datum type: Parametric.
Used with coordinate system type: Parametric.

## Immutability and thread safety

This class is immutable and thus thread-safe if the property values (not necessarily the map itself), the coordinate system and the datum instances given to the constructor are also immutable. Unless otherwise noted in the javadoc, this condition holds if all components were created using only SIS factories and static constants.

Since:
  0.7
See Also:
  - `DefaultParametricDatum`
  - `DefaultParametricCS`
  - `GeodeticAuthorityFactory​.createParametricCRS(String)`
  - Serialized Form

- ## Field Summary

  ### Fields inherited from class AbstractIdentifiedObject

  `DEPRECATED_KEY, DOMAINS_KEY, LOCALE_KEY`

  ### Fields inherited from interface IdentifiedObject

  `ALIAS_KEY, IDENTIFIERS_KEY, NAME_KEY, REMARKS_KEY`

  ### Fields inherited from interface ReferenceSystem

  `DOMAIN_OF_VALIDITY_KEY, SCOPE_KEY`

- ## Constructor Summary

  Constructors
  Modifier
  Constructor
  Description
  ``
  `DefaultParametricCRS(Map<String,?> properties, DefaultParametricDatum datum, DefaultParametricCS cs)`
  Deprecated, for removal: This API element is subject to removal in a future version.
  A `DefaultDatumEnsemble` argument has been added.
  ``
  `DefaultParametricCRS(Map<String,?> properties, DefaultParametricDatum datum, DefaultDatumEnsemble<DefaultParametricDatum> ensemble, DefaultParametricCS cs)`
  Creates a coordinate reference system from the given properties, datum and coordinate system.
  `protected`
  `DefaultParametricCRS(DefaultParametricCRS crs)`
  Constructs a new coordinate reference system with the same values as the specified one.

- ## Method Summary

  Modifier and Type
  Method
  Description
  `DefaultParametricCRS`
  `forConvention(AxesConvention convention)`
  Returns a CRS equivalent to this one but with axes rearranged according the given convention.
  `protected String`
  `formatTo(Formatter formatter)`
  Formats this CRS as a Well Known Text `ParametricCRS[…]` element.
  `DefaultParametricCS`
  `getCoordinateSystem()`
  Returns the coordinate system.
  `DefaultParametricDatum`
  `getDatum()`
  Returns the reference surface used as the origin of this CRS.
  `DefaultDatumEnsemble<DefaultParametricDatum>`
  `getDatumEnsemble()`
  Returns a collection of datums which, for low accuracy requirements, may be considered to be insignificantly different from each other.
  `Class<? extends SingleCRS>`
  `getInterface()`
  Returns the GeoAPI interface implemented by this class.

  ### Methods inherited from class AbstractCRS

  `castOrCopy`

  ### Methods inherited from class AbstractReferenceSystem

  `getDomainOfValidity, getScope`

  ### Methods inherited from class AbstractIdentifiedObject

  `castOrCopy, equals, formatTo, getAlias, getDescription, getDomains, getIdentifiers, getName, getRemarks, hashCode, isDeprecated, isHeuristicMatchForName`

  ### Methods inherited from class FormattableObject

  `print, toString, toString, toWKT`

  ### Methods inherited from class Object

  `clone, finalize, getClass, notify, notifyAll, wait, wait, wait`

  ### Methods inherited from interface IdentifiedObject

  `getAlias, getIdentifiers, getName, getRemarks, toWKT`

  ### Methods inherited from interface ReferenceSystem

  `getDomainOfValidity, getScope`

- ## Constructor Details

  - ### DefaultParametricCRS

    public DefaultParametricCRS(Map<String,?> properties, DefaultParametricDatum datum, DefaultDatumEnsemble<DefaultParametricDatum> ensemble, DefaultParametricCS cs)
    Creates a coordinate reference system from the given properties, datum and coordinate system. At least one of the `datum` and `ensemble` arguments shall be non-null. The properties given in argument follow the same rules as for the super-class constructor. The following table is a reminder of main (not all) properties:

    Recognized properties (non exhaustive list)
    Property name | Value type | Returned by
    --- | --- | ---
    "name" | `Identifier` or `String` | `AbstractIdentifiedObject.getName()`
    "alias" | `GenericName` or `CharSequence` (optionally as array) | `AbstractIdentifiedObject.getAlias()`
    "identifiers" | `Identifier` (optionally as array) | `AbstractIdentifiedObject.getIdentifiers()`
    "domains" | `DefaultObjectDomain` (optionally as array) | `AbstractIdentifiedObject.getDomains()`
    "remarks" | `InternationalString` or `String` | `AbstractIdentifiedObject.getRemarks()`

    Warning: in a future SIS version, the parameter types may be changed to `org​.opengis​.referencing​.datum​.ParametricDatum` and `org​.opengis​.referencing​.cs​.ParametricCS` Those change are pending GeoAPI revision.
    Parameters:
      `properties` - the properties to be given to the coordinate reference system.
      `datum` - the datum, or `null` if the CRS is associated only to a datum ensemble.
      `ensemble` - collection of reference frames which for low accuracy requirements may be considered to be insignificantly different from each other, or `null` if there is no such ensemble.
      `cs` - the coordinate system.
    Since:
      1.5

  - ### DefaultParametricCRS

    @Deprecated(since="1.5", forRemoval=true) public DefaultParametricCRS(Map<String,?> properties, DefaultParametricDatum datum, DefaultParametricCS cs)
    Deprecated, for removal: This API element is subject to removal in a future version.
    A `DefaultDatumEnsemble` argument has been added.

  - ### DefaultParametricCRS

    protected DefaultParametricCRS(DefaultParametricCRS crs)
    Constructs a new coordinate reference system with the same values as the specified one. This copy constructor provides a way to convert an arbitrary implementation into a SIS one or a user-defined one (as a subclass), usually in order to leverage some implementation-specific API.

    This constructor performs a shallow copy, i.e. the properties are not cloned.

    Warning: in a future SIS version, the parameter type may be changed to `org​.opengis​.referencing​.crs​.ParametricCRS`. This change is pending GeoAPI revision.
    Parameters:
      `crs` - the coordinate reference system to copy.

- ## Method Details

  - ### getDatum

    public DefaultParametricDatum getDatum()
    Returns the reference surface used as the origin of this CRS. This property may be null if this CRS is related to an object identified only by a datum ensemble.
    Specified by:
      `getDatum` in interface `SingleCRS`
    Returns:
      the parametric datum, or `null` if this CRS is related to an object identified only by a datum ensemble.

  - ### getDatumEnsemble

    public DefaultDatumEnsemble<DefaultParametricDatum> getDatumEnsemble()
    Returns a collection of datums which, for low accuracy requirements, may be considered to be insignificantly different from each other. This property may be null if this CRS is related to an object identified only by a single datum.
    Warning: in a future SIS version, the return type may be changed to the `org​.opengis​.referencing​.datum​.DatumEnsemble` interface. This change is pending GeoAPI revision.
    Returns:
      the datum ensemble, or `null` if this CRS is related to an object identified only by a single datum.
    Since:
      1.5

  - ### getCoordinateSystem

    public DefaultParametricCS getCoordinateSystem()
    Returns the coordinate system.
    Specified by:
      `getCoordinateSystem` in interface `CoordinateReferenceSystem`
    Specified by:
      `getCoordinateSystem` in interface `SingleCRS`
    Overrides:
      `getCoordinateSystem` in class `AbstractCRS`
    Returns:
      the coordinate system.

  - ### forConvention

    public DefaultParametricCRS forConvention(AxesConvention convention)
    Returns a CRS equivalent to this one but with axes rearranged according the given convention. If this CRS is already compatible with the given convention, then this method returns `this`.
    Overrides:
      `forConvention` in class `AbstractCRS`
    Parameters:
      `convention` - the axes convention for which a coordinate reference system is desired.
    Returns:
      a coordinate reference system compatible with the given convention (may be `this`).
    See Also:
      - `AbstractCS​.forConvention(AxesConvention)`

  - ### formatTo

    protected String formatTo(Formatter formatter)
    Formats this CRS as a Well Known Text `ParametricCRS[…]` element.

    #### Compatibility note

    `ParametricCRS` is defined in the WKT 2 specification only.
    Overrides:
      `formatTo` in class `AbstractCRS`
    Parameters:
      `formatter` - the formatter where to format the inner content of this WKT element.
    Returns:
      `"ParametricCRS"`.
    See Also:
      - `FormattableObject​.toWKT()`
      - `FormattableObject​.toString()`

  - ### getInterface

    public Class<? extends SingleCRS> getInterface()
    Returns the GeoAPI interface implemented by this class. The default implementation returns `SingleCRS​.class`. Subclasses implementing a more specific GeoAPI interface shall override this method.
    Overrides:
      `getInterface` in class `AbstractCRS`
    Returns:
      the coordinate reference system interface implemented by this class.